var d = Object.defineProperty;
var l = (o, i, t) => i in o ? d(o, i, { enumerable: !0, configurable: !0, writable: !0, value: t }) : o[i] = t;
var e = (o, i, t) => (l(o, typeof i != "symbol" ? i + "" : i, t), t);
import { autoUpdate as p, computePosition as u, shift as c, flip as m } from "@floating-ui/dom";
import { hello as v, goodbye as b } from "hello-goodbye";
const r = class extends HTMLElement {
  constructor() {
    super(...arguments);
    e(this, "parent");
    e(this, "tooltip");
    e(this, "timeout");
    e(this, "disabledObserver");
    e(this, "showing", !1);
    e(this, "cleanup");
    e(this, "prevInnerHTML");
    e(this, "onMouseEnter", this.afterDelay.bind(this, this.show));
    e(this, "onFocus", this.show.bind(this));
    e(this, "onMouseLeave", this.afterDelay.bind(this, this.hide));
    e(this, "onBlur", this.hide.bind(this));
    e(this, "onPointerUp", (t) => {
      t.pointerType === "mouse" ? this.hide() : this.show();
    });
    e(this, "onKeyDown", (t) => {
      t.key === "Escape" && this.hide();
    });
  }
  connectedCallback() {
    this.parent = this.parentNode, this.parent && (this.parent.addEventListener("mouseenter", this.onMouseEnter), this.parent.addEventListener("focus", this.onFocus), this.parent.addEventListener("mouseleave", this.onMouseLeave), this.parent.addEventListener("blur", this.onBlur), this.parent.addEventListener("pointerup", this.onPointerUp), this.disabledObserver = new MutationObserver((t) => {
      t.forEach((s) => {
        s.attributeName === "disabled" && this.hide();
      });
    }), this.disabledObserver.observe(this.parent, { attributes: !0 })), document.addEventListener("keydown", this.onKeyDown), document.addEventListener("scroll", this.onBlur);
  }
  disconnectedCallback() {
    var t;
    this.tooltip && (this.tooltip.remove(), this.tooltip = void 0), this.parent && (this.parent.removeEventListener("mouseenter", this.onMouseEnter), this.parent.removeEventListener("focus", this.onFocus), this.parent.removeEventListener("mouseleave", this.onMouseLeave), this.parent.removeEventListener("blur", this.onBlur), this.parent.removeEventListener("pointerup", this.onPointerUp), this.parent = void 0), document.removeEventListener("keydown", this.onKeyDown), document.removeEventListener("scroll", this.onBlur), (t = this.disabledObserver) == null || t.disconnect(), clearTimeout(this.timeout);
  }
  get disabled() {
    return this.hasAttribute("disabled");
  }
  set disabled(t) {
    t ? this.setAttribute("disabled", "") : this.removeAttribute("disabled");
  }
  show() {
    if (this.disabled)
      return;
    const t = this.createTooltip();
    clearTimeout(this.timeout), this.showing || (t.hidden = !1, v(t), this.showing = !0), this.innerHTML !== this.prevInnerHTML && (this.prevInnerHTML = t.innerHTML = this.innerHTML), t.style.position = "absolute", this.cleanup = p(
      this.parent,
      t,
      () => u(this.parent, t, {
        placement: this.getAttribute("placement") || r.placement,
        middleware: [c(), m()]
      }).then(({ x: s, y: h, placement: a }) => {
        Object.assign(t.style, {
          left: `${s}px`,
          top: `${h}px`
        }), t.dataset.placement = a;
      })
    );
  }
  hide() {
    var t;
    clearTimeout(this.timeout), (t = this.cleanup) == null || t.call(this), this.showing && (this.showing = !1, b(this.tooltip).then(() => {
      this.tooltip && (this.tooltip.hidden = !0);
    }));
  }
  afterDelay(t) {
    clearTimeout(this.timeout);
    const s = parseInt(this.getAttribute("delay") || "");
    this.timeout = window.setTimeout(
      t.bind(this),
      isNaN(s) ? r.delay : s
    );
  }
  createTooltip() {
    return this.tooltip || (this.tooltip = document.createElement("div"), this.tooltip.className = this.getAttribute("tooltip-class") || r.tooltipClass, this.tooltip.hidden = !0, this.tooltip.addEventListener("mouseenter", this.show.bind(this)), this.tooltip.addEventListener(
      "mouseleave",
      this.afterDelay.bind(this, this.hide)
    ), document.body.appendChild(this.tooltip)), this.tooltip;
  }
};
let n = r;
e(n, "delay", 100), e(n, "placement", "top"), e(n, "tooltipClass", "tooltip");
export {
  n as default
};
