export type AlertOptions = {
    key?: string;
    duration?: number;
    animate?: boolean;
};
export default class AlertsElement extends HTMLElement {
    static duration: number;
    private timeouts;
    private index;
    constructor();
    connectedCallback(): void;
    show(el: HTMLElement, options?: AlertOptions): string;
    dismiss(el: HTMLElement): void;
    dismiss(key: string): void;
    clear(): void;
    speak(message: string): void;
    private startTimeout;
    private clearTimeout;
}
